/***************************************************
* By CCSC compiler
*  File Name: 20180108_K499_MK333_1827.c
*  Description: check AM2302, show it, turn on relay and LED
*  rev 1.0
*  COPYRIGHT 2018 MYCOMKITS.COM, owned by CNET LIMITED
***************************************************/
//
#include <16f1827.h>
#DEVICE ADC=10
#fuses	INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCPD, NOCLKOUT, NOWRT, NOIESO, NOFCMEN, PLL_SW, NOSTVREN
#use	delay(CLOCK = 32000000)
//#use	rs232(BAUD=9600, XMIT=PIN_A1)
#include <stdlib.h>
//
#use	fast_io(a)
#use	fast_io(b)
//
#ROM getenv("EEPROM_ADDRESS") ={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF }   //
//
#define	Bmode 0x00			//port B all OUT 
#define Amode 0x3C			//port A all in, except A1, 0 
//////// ds18B20 temperature sensor, one wire
#define AM2302_SDA PIN_A2
#define SET_SW PIN_A5
#define RELAY PIN_A1
#define MODE_SW PIN_A3  // 0=RH
// variables
float tempo_value_f = 0;	// 
float set_value_f = 0;	// 
//float coef = 0.9;
int hyste = 0;
long number = 0; 
float numberf = 0;                 // -20 to +120, 7 seg data
float numberf_tempo = 0;
int  digit = 2;                  //2, 1, 0 for flag for digit
int minus = 0;
int nondot = 0;
long stable = 3000;	// wait 15 sec to make AM2302 stable 
//conversion teble for 7 seg LED, B7 to B1, B0=1, 0,1,2,3,4,5,6,7,8,9,-,E,r,T,n
int const LED_SEG[15] = {0x7F, 0x19, 0xB7, 0xBD, 0xD9, 0xED,
                            0xEF, 0x39, 0xFF, 0xF9, 0x80, 0xE6, 0x82, 0x98, 0x8A};
int time_out=0;
int Temp_byte1, Temp_byte2, RH_byte1, RH_byte2, CheckSum;
long Temp, RH;
float Tempf, RHf;
int RH_MODE=1;  // 1=RH, 0=Temp
float disp_period=0; //3000 for 2sec
float RH_set_value_f;
float Temp_set_value_f;
int i, k, tempo_data = 0;
int set_memory_flag=0;
float hyste_value=5;    // 5 % or 5 degree
float hyste_value_temp=5;    // 5 degree
float hyste_value_rh=5;    // 5 %
int init_disp=1;
int hyste_mode;  //1 is time, 2= temperature degree or RH%
// prototyping
#separate
void am2302_read();
#separate
void initializing();
#separate
void get_adc(); 
#separate
void value_check();
#separate
void onewire_start();
#separate
int onewire_read();
#separate
int onewire_response();
#separate
void timeout_error();
#separate
void display7seg();
#separate
void test();
#separate
void sending_out();
#separate
void WRITE_FLOAT_EEPROM(int x, float y);
#separate
float READ_FLOAT_EEPROM(int x);
// main function
void main()
{
	initializing();
    delay_ms(5000); //wait to start AM2302
	// main loop
	while(1)
	{
        if(input(SET_SW) == 0)	// set and show threshold value
		{
			time_out=0;
            if(input(MODE_SW)==0) RH_MODE=1;
            else RH_MODE=0;
            get_adc();
			numberf_tempo = set_value_f;
			value_check();
            set_memory_flag = 1;
		}
		else    // measure and show actual value
		{
            if(set_memory_flag == 1)
            {
                if(RH_set_value_f != READ_FLOAT_EEPROM(0))
                {
                    WRITE_FLOAT_EEPROM(0, RH_set_value_f);
                }

                if(Temp_set_value_f != READ_FLOAT_EEPROM(4))
                {
                    WRITE_FLOAT_EEPROM(4, Temp_set_value_f);
                }
                set_memory_flag = 0;
            }
            disp_period= disp_period-0.1;
            if(disp_period<0) 
            {
                disp_period=4500;   //3000 for 2sec
                time_out = 0;
                minus=0;
                am2302_read();
                //
            }
            if(input(MODE_SW)==0)   // RH mode 
            {
                if(RH_MODE==0) 
                {
                    RH_MODE=1;
                    set_value_f = RH_set_value_f;
                    stable = 600;   // not turn on 3 seconds
                }
                RH_MODE=1;
                tempo_value_f = RHf;
                hyste_value = hyste_value_rh;
            }
            else 
            {
                if(RH_MODE==1) 
                {
                    RH_MODE=0;
                    set_value_f = Temp_set_value_f;
                    stable = 600;   // not turn on 3 seconds
                }
                RH_MODE=0;
                tempo_value_f = Tempf;
                hyste_value = hyste_value_temp;
            }
        }
        //
		if(stable == 0)
		{
			if(tempo_value_f >= set_value_f) 
			{
				output_high(RELAY);	// relay ON
                hyste = 200;	// hold one second
			}		
			else if((hyste_mode==1) && (hyste == 0))
			{
				output_low(RELAY);	// relay OFF
			}
            else if((hyste_mode==2) && (tempo_value_f < (set_value_f-hyste_value)))
            {
                output_low(RELAY);	// relay OFF
            }
		}
	}	
}
//timer 1, wait time count down the timer value at every 10msec.
#int_timer1
void isr1(void)	
{
	set_timer1(0xFD8F);	// setting timer 1. almost 5msec
    //
	if(digit == 2)	// x10 digit
	{
		digit = 1;	// change flag
    	output_low(PIN_A0);	// x0.1 turn off
        if(init_disp==1) 
        {
            if(hyste_mode ==1) output_b(LED_SEG[13]);    //Time
            else output_b(LED_SEG[14]); //Number
        }
        else if(time_out==1)
        {
            output_b(LED_SEG[11]);
        }
    	else if(RH_MODE==1 || (RH_MODE==0 && minus==0))
    	{
    		number = numberf;
    		output_b(LED_SEG[(number / 10)]);   // convert and display
    	}
    	else output_b(LED_SEG[10]);   // minus and display	
    	output_high(PIN_A6);	// x10 turn on
	}	
    else if(digit == 1)	// x1 digit
    {
    	digit = 0;	// change flag
    	output_low(PIN_A6);	// x10 turn off
        if(time_out==1)
        {
            output_b(LED_SEG[12]);
        }
    	else
        {
            number = numberf;
            output_b(LED_SEG[(number % 10)]);   // convert and display
            if(nondot == 1) output_low(PIN_B0);
        }
        //else output_b(LED_SEG[10]);   // minus and display
    	output_high(PIN_A7);	// x1 turn on
    }
    else 	// x0.1 digit
    {
    	digit = 2;	// change flag
    	output_low(PIN_A7);	// x1 turn off
        if(time_out==1)
        {
            output_b(LED_SEG[12]);
        }
    	else
        {
            number = numberf * 10;
            output_b(LED_SEG[(number % 10)]);	// convert and display
        }
        //else output_b(LED_SEG[10]);   // minus and display
    	output_high(PIN_A0);	// x0.1 turn on
    }
    //
    if(hyste > 1) hyste = hyste - 1;	// check hysterisys value to keep 1sec
	else hyste = 0; 
	//
	if(stable > 1) stable = stable - 1;
	else stable = 0; 
}
//
#separate
void am2302_read()
{
    disable_interrupts(INT_TIMER1);
    onewire_start();
    if(onewire_response())
    { // If there is response from sensor
        RH_byte1 = onewire_read(); // read RH byte1
        RH_byte2 = onewire_read(); // read RH byte2
        Temp_byte1 = onewire_read(); // read T byte1
        Temp_byte2 = onewire_read(); // read T byte2
        Checksum = onewire_read(); // read checksum
        //
        if(time_out==0)
        {
            if(CheckSum == ((RH_Byte1 + RH_Byte2 + Temp_Byte1 + Temp_Byte2) & 0xFF))
            {
                char string1[5];
                RH = make16(RH_byte1, RH_byte2);
                RH = atol(itoa(RH, 10, string1));
                RHf = RH;
                RHf = RHf/10;
                //
                if((Temp_byte1 & 0x80)==0x80) 
                {
                    minus=1;
                    Temp_byte1 = Temp_byte1 & 0x7F;   // clrear MSB
                }
                else minus=0;
                Temp = make16(Temp_byte1, Temp_byte2);
                Temp = atol(itoa(Temp, 10, string1));
                Tempf = Temp;   // Temp is always positive, if it is negative value
                //
                if(RH_MODE == 0)
                {
                    if(minus == 1) Tempf = 0 - Tempf;
                    Tempf = Tempf/10;
                    numberf_tempo = Tempf; 
                    value_check();
                }
                else
                {
                    numberf_tempo = RHf; 
                    value_check();
                }
            }
        }
    }
    enable_interrupts(INT_TIMER1);
}
//
#separate
void initializing() 
{
	set_tris_a(Amode);	//
	set_tris_b(Bmode);	//
	//
	setup_comparator(NC_NC_NC_NC);
	setup_dac(DAC_OFF);
	// A/D converter initialize 
	setup_adc_ports(sAN4 | VSS_VDD);	// gnd to 5.0V
	setup_adc(ADC_CLOCK_DIV_16);	// 2usec	
	// initialize timer 1 for repeat play
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);	// one cycle 8us
	set_timer1(0xFD8F);              // setting almost 5msec
	output_b(0x00);
	output_a(0x30);
    //
    if(input(MODE_SW)==0) RH_MODE=1;
    else RH_MODE=0;
    //check last set_valuef
    float temporalf;
    temporalf = READ_FLOAT_EEPROM(0);
    if((temporalf<0) || (temporalf>99.9))
    {
        RH_set_value_f = 99.9;
        WRITE_FLOAT_EEPROM(0,RH_set_value_f);
    }
    else RH_set_value_f = temporalf; 
    temporalf = READ_FLOAT_EEPROM(4);
    if((temporalf<-40) || (temporalf>80))
    {
        Temp_set_value_f = 80;
        WRITE_FLOAT_EEPROM(4, Temp_set_value_f);
    }
    else Temp_set_value_f = temporalf;
    //
    hyste_mode = read_eeprom(8);
    if((hyste_mode < 1) || (hyste_mode > 2)) 
    {
        hyste_mode = 1;    //1 = time, 2= degree or %
        write_eeprom(8, hyste_mode);
    }
    //
    if(RH_MODE == 1) set_value_f = RH_set_value_f;
    else set_value_f = Temp_set_value_f;    
	enable_interrupts(INT_TIMER1);   // enable timer 1
	enable_interrupts(GLOBAL);
    //
    delay_ms(1000); //show hyst mode
    if(input(SET_SW) == 0)
    {
        if(hyste_mode == 1) hyste_mode = 2;
        else hyste_mode = 1;
        write_eeprom(8, hyste_mode);
        delay_ms(1000); //show hyst mode
        while(input(SET_SW) == 0) {}
    }
    init_disp = 0;
    numberf_tempo = RH_set_value_f;
    value_check();
    delay_ms(1000);
    numberf_tempo = Temp_set_value_f;
    value_check();
    delay_ms(1000);
    numberf_tempo = 0;
    value_check();
}	
//
#separate
void get_adc()
{
	disable_interrupts(INT_TIMER1);
	//
	set_adc_channel(4);	//must wait 65u, AN4
	delay_us(100);
	set_value_f = read_adc();	// 0 to 1023, 0V to 5.0V
	//
    if(RH_MODE==0)  // 1=RH, 0=Temperature 
    {
        set_value_f = (set_value_f * 120/0x3FF)-40;	// -40 to 80, float
        if(set_value_f > 80) set_value_f = 80;
        if(set_value_f < -40) set_value_f = -40;
        Temp_set_value_f= set_value_f;
    }
    else
    {
        set_value_f = (set_value_f * 100/0x3FF);	// convert it to 0 to 100, float
        if(set_value_f > 99.9) set_value_f = 99.9;
        RH_set_value_f= set_value_f;
    }
	//
	enable_interrupts(INT_TIMER1);
}	
// only for display, make all number to positive with minus flag, if negative
#separate
void value_check()
{
	if(RH_MODE == 0) 	// only for temperature, set minus value
    {
        if(numberf_tempo < 0) 	// minus value
        {
            if(numberf_tempo < -40 ) numberf_tempo = -40;	//under -40, regulate
            if(numberf_tempo < -9.9) 	// under -9.9
            {
                numberf_tempo = numberf_tempo/10;
                nondot = 1;
            }	
            else nondot = 0;
        }
        else 	// plus value
        {
            minus = 0;	
            if(numberf_tempo >80 ) numberf_tempo = 80;	//over 80, regulate 	
            //
        }	
    }
    numberf = numberf_tempo;
    if(numberf < 0) 
    {
        numberf = 0 - numberf;
        minus = 1;
    }
    else minus = 0;
    //numberf must be always positve,
}	
//
#separate
void onewire_start()  // OK if just using a single permanently connected device
{
	set_tris_a(0x38);	// set PIN_A2 to 0 for output
	output_low(AM2302_SDA);
	delay_ms(10); // set AM2302 low for reset pulse, typ 1ms
    output_high(AM2302_SDA);
    delay_us(20);   //min 20us
    set_tris_a(0x3C);	// set PIN_A2 to 1 for input
} 
//
#separate
short onewire_response()
{
    delay_us(40);
    while(input(AM2302_SDA)==0) {}
    while(input(AM2302_SDA)==1) {}
    return 1;
}
//
#separate
unsigned int8 onewire_read()
{
    //
    for(i = 0; i < 8; i++)
    {
        k = 0;
        while(input(AM2302_SDA)==0)
        { // Wait until pin goes high
            k++;
            if (k > 100) 
            {
                time_out = 1; 
                break;
            }
            delay_us(1);
        }
        delay_us(30);
        if(input(AM2302_SDA)==0) bit_clear(tempo_data, (7 - i)); // Clear bit (7 - i)
        else
        {
            bit_set(tempo_data, (7 - i)); // Set bit (7 - i)
            k = 0;
            while(input(AM2302_SDA)==1)
            { // Wait until pin goes low
                k++;
                if (k > 100) 
                {
                    time_out = 1; 
                    break;
                }
                delay_us(1);
            }
        }
    }
    return tempo_data;
}
//
#separate
void test()
{
    if(numberf<99.9) numberf=numberf+0.1;
    else numberf=0;
    delay_ms(300);
}
//
#separate
void timeout_error()
{
    RHf=99.9;
    Tempf=99.9;
}
//
#separate
void display7seg()	
{
	if(digit == 2)	// x10 digit
	{
		digit = 1;	// change flag
    	output_low(PIN_A0);	// x0.1 turn off
    	if(minus == 0)
    	{
    		number = numberf;
    		output_B(LED_SEG[(number / 10)]);   // convert and display
    	}
    	else output_B(LED_SEG[10]);   // minus and display	
    	output_high(PIN_A6);	// x10 turn on
	}	
    else if(digit == 1)	// x1 digit
    {
    	digit = 0;	// change flag
    	output_low(PIN_A6);	// x10 turn off
    	number = numberf;
    	output_B(LED_SEG[(number % 10)]);   // convert and display
    	if(nondot == 1) output_low(PIN_B0);
    	output_high(PIN_A7);	// x1 turn on
    }
    else 	// x0.1 digit
    {
    	digit = 2;	// change flag
    	output_low(PIN_A7);	// x1 turn off
    	number = numberf * 10;
    	output_B(LED_SEG[(number % 10)]);	// convert and display
    	output_high(PIN_A0);	// x0.1 turn on
    }
    //
    if(hyste > 1) hyste = hyste - 1;	// check hysterisys value to keep 1sec
	else hyste = 0; 
	//
	if(stable > 1) stable = stable - 1;
	else stable = 0; 
}
//write_float_to_eeprom;
#separate
void WRITE_FLOAT_EEPROM(int addr, float data) 
{
   int8 j;
   for(j = 0; j < 4; j++)
	{
		write_eeprom(addr + j, *((int8*)&data + j));
		delay_ms(20);
	}  
}
//read_float_from_eeprom;
#separate
float READ_FLOAT_EEPROM(int addr) 
{   
    int8 j;
	float data=0;
	for(j = 0; j < 4; j++)
	{      
		*((int8*)&data + j) = read_eeprom(addr + j);
		delay_ms(20);      
	}
	return(data);
}
//



